******************************************************************************
*									     *
*                BIT REVERSE ROUTINE       :  BITREV.ASM                     *
*             --------------------------------------------     		     *
*									     *
*    REVISION:   DANIEL MAZZOCCO   TI HOUSTON              APR 27,1992       *
*                MADE IT C CALLABLE                                          *
*									     *
*                                                                            *
*    SYNOPSIS: int  bitrev( SIN_TABLE, QUART_SIZE)                           *
*            float   *SIN_TABLE      ; Points to the SIN table.              *
*            int     QUART_SIZE      ; FFT SIZE divided by four              *
******************************************************************************

FP		.set	AR3
                .global _bitrev          ; Entry execution point.

                .bss   SIN_TABLE  ,1
                .bss   QUART_SIZE ,1

                .text
;
; Initialise C Function.
;

_bitrev:        PUSH    FP
		LDI	SP,FP
		PUSH	R4
		PUSH	R5
                PUSH	R6
		PUSHF	R6
		PUSH	R7
		PUSHF	R7
		PUSH	AR4
		PUSH	AR5
		PUSH	AR6
		PUSH	AR7

                LDI     *-FP(2),R0
                STI     R0,@SIN_TABLE
                LDI     *-FP(3),R0
                STI     R0,@QUART_SIZE

****  Do bit reverse on Sine Table
        ldi     @SIN_TABLE,ar0         ; ar0 points to twiddle factor 1
        ldi     @SIN_TABLE,ar1         ; ar1 points to twiddle factor 1
        ldi     @QUART_SIZE,RC
        ldi     @QUART_SIZE,IR0
        SUBI    1,RC
        RPTB    BITRV1
	CMPI	AR0,AR1
        BGE     CONT1
	LDF	*AR0,R0
||	LDF	*AR1,R1
	STF	R0,*AR1
||	STF	R1,*AR0
	LDF	*+AR0(1),R0
||	LDF	*+AR1(1),R1
	STF	R0,*+AR1(1)
||	STF	R1,*+AR0(1)
CONT1   NOP     *++AR0(2)
BITRV1  NOP     *AR1++(IR0)B

;
; Return to C environment.
;

		POP	AR7
		POP	AR6
		POP	AR5
		POP	AR4
		POPF	R7
		POP	R7
		POPF	R6
		POP	R6
		POP	R5
		POP	R4
		POP	FP
		RETS


	.end

