/************************************************************************/
/*   FFT.CMD                                                            */
/*                                                                      */
/*   TMS320C30 EVALUATION MODULE REAL FFT CHECK-UP                      */
/*            PROGRAM LINK COMMAND FILE                                 */
/*   Used with 4.4 C compiler.                                          */
/*   Daniel Mazzocco , 6th March 1992                                   */
/*   TEXAS INSTRUMENTS, HOUSTON                                         */
/************************************************************************/

-c
forfft.obj
forfftc.obj
-o forfft.out
-l rts30.lib

MEMORY
{
   VECS:   org = 0        len = 0x40       /* RESERVED VECTOR LOCATIONS */
   SRAM:   org = 0x40     len = 0x3FC0     /* PRIMARY BUS SRAM (16K)    */
   RAM0:   org = 0x809800 len = 0x400      /* INTERNAL RAM0(1K)         */
   RAM1:   org = 0x809C00 len = 0x400      /* INTERNAL RAM1(1K)         */
}

SECTIONS
{
   .vecs:	{} > VECS		   /* RESET/INTERRUPT VECTORS   */
   .text:   	{} > SRAM                  /* CODE                      */
   .cinit:  	{} > SRAM                  /* C INITIALIZATION TABLES   */
   .fftdata:    {} > RAM0
   .ffttext:    {} > RAM0
   .sysmem: 	{} > SRAM
   .bss:        {} > RAM0                  /* C VARIABLES               */
   .data:       {} > RAM0                  /* ASSEMBLY CODE CONSTANTS   */
   .stack:      {} > SRAM
}

